﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	
	import flash.display.LoaderInfo;
	import flash.text.TextField;
	import flash.net.URLRequest;
	import flash.events.IOErrorEvent;
	import flash.display.Loader;


	import com.as3facile.DefaultButton;

	import flash.events.Event;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	
	import com.demonsters.debugger.MonsterDebugger;


	public class Main extends Sprite
	{
		private var oTxtListener : TxtReceive;
		private var oTxtInput : TxtInput;

		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			
			// chargement des polices partagées
			//------------------------
			var _loader:Loader = new Loader();
			_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, completeHandler );
			_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, errorHandler );
			
			//var sFont:String = "http://www.actionscript-facile.com/ressources/swf/FDT/fonts.swf?r="+Math.random()*28;
			var sFont:String = "fonts.swf?r="+Math.random()*28;
			MonsterDebugger.trace(this, "url : "+sFont); 

			var file:URLRequest =  new URLRequest(sFont);
			_loader.load(file );
		}


		/**
		 * Création de l'interface utilisateur.
		 * 
		 */
		private function setupUI() : void
		{
			oTxtInput = new TxtInput();
			oTxtInput.x = oTxtInput.y = 30;
			this.addChild(oTxtInput);
			
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "C'est parti !";
			oBtnStart.getObject().x = 230;
			oBtnStart.getObject().y = oTxtInput.y + oTxtInput.height + 20;
			//oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onSeeParam );
			oBtnStart.click.add(onClickBtn);// écoute l'évènement CLICK sur la souris avec AS3 Signals
			this.addChild(oBtnStart);
			
			
			oTxtListener = new TxtReceive();
			oTxtListener.x = oTxtInput.x;
			oTxtListener.y = oBtnStart.getObject().y + oBtnStart.getObject().height + 10;
			this.addChild(oTxtListener);
			
			// Main écoute les changement de l'objet oTxtInput (qui diffuse des évènements AS3 Signals)
			oTxtInput.event.add(onUpdateReceiveTxt);
			
			//oTxtInput.event.addOnce(onUpdateReceiveTxt);// écouteur appelé une seul fois puis il est supprimé automatiquement
			//oTxtInput.event.remove(onUpdateReceiveTxt);// supprimer un écouteur
			//oTxtInput.event.removeAll();// supprime tous les écouteurs automatiquement
			
			oBtnStart.dispatchEvent(new MouseEvent("click") ); // simulation évènement CLICK
		}
		
		/**
		 * Affiche les paramètres transmis avec l'évènement.
		 * Appelé par AS3 Signals.
		 * 
		 */
		private function onUpdateReceiveTxt(sValue:String, bUpdate:Boolean) : void
		{
			if(bUpdate)	oTxtListener.update("---> "+sValue);
			else	oTxtListener.update(sValue+" <---");
		}
		
		
		/**
		 * Click de l'utilisateur sur le bouton.
		 * 
		 */
		private function onClickBtn(event : MouseEvent) : void
		{
			MonsterDebugger.trace(this, "onClickBtn----");
			oTxtInput.onChange();
		}

		
		/**
		 * Utilisation des polices partagées dynamiques
		 * 
		 */
		private function completeHandler(event : Event) : void
		{
			MonsterDebugger.trace(this, "completeHandler");
			this.setupUI();
		}
		
		/**
		 * Gestion des erreurs de chargement.
		 * 
		 */
		private function errorHandler(e:IOErrorEvent):void 
		{
			MonsterDebugger.trace(this,"erreur de chargement : " + e.text);
			
			var contentLoaderInfo:LoaderInfo = LoaderInfo( e.target);
			contentLoaderInfo.removeEventListener(Event.COMPLETE, completeHandler );
			contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, errorHandler );
			
			
			var text:TextField = addChild( new TextField() ) as TextField;
			text.width = stage.stageWidth;
			text.autoSize = 'center';
			text.text = "Erreur de chargement : "+e.text;
		}
				
	}
}
